<?php
// $Id: sasql_hooks.php,v 1.13 2004/03/29 23:12:43 bucovina Exp $

//error_reporting('E_ALL');

if (!defined ('SM_PATH')) { define('SM_PATH', '../../'); }
// This include breaks a lot of things for reasons I don't get.
#include_once(SM_PATH.'plugins/sasql/sasql_conf.php');

function sasql_special_folder_check ($box)
{
  // This only seems to work with include() but not include_once()
  // and, for some reason, I can't leave out the include and
  // use global.
  include(SM_PATH.'plugins/sasql/sasql_conf.php');

  //global $special_spam_folder, $spam_folder;
  //echo "Foo: $special_spam_folder<br>";
  if (! $special_spam_folder) { return 0; }

  global $default_folder_prefix;
  if ($box == $default_folder_prefix.$spam_folder
      || $box == $default_folder_prefix.$learn_spam_folder
      || $box == $default_folder_prefix.$learn_fp_folder
      ) {
    return 1;
  } else {
    return 0;
  }
}

function sasql_autocreate_spam_folder () {
  // This only seems to work with include() but not include_once().
  include(SM_PATH.'plugins/sasql/sasql_conf.php');

  //echo "Bar: $special_spam_folder";
  //global $special_spam_folder, $spam_folder;
  if (! $special_spam_folder) { return 0; }

  include_once(SM_PATH.'functions/imap.php');
  /* get those globals */

  sqgetGlobalVar('username', $username, SQ_SESSION);
  sqgetGlobalVar('key', $key, SQ_COOKIE);
  sqgetGlobalVar('delimiter', $delimiter, SQ_SESSION);
  sqgetGlobalVar('onetimepad', $onetimepad, SQ_SESSION);

  global $default_folder_prefix, $imapServerAddress, $imapPort;
  global $imap_server_type;
  /* finished globals */

  $boxes = array($spam_folder, $learn_spam_folder, $learn_fp_folder);
  
  $imap_stream = sqimap_login($username, $key, $imapServerAddress, $imapPort, 0);

  foreach ($boxes as $box) {


    if (! $box or $box == '') {
      //echo "<foo sasql missing: $box />";
      continue;
    }

    $mailbox = $default_folder_prefix.$box;

    // echo "<foo sasql imap_server_type: $imap_server_type />";

    if (!sqimap_mailbox_exists($imap_stream, $mailbox)) {
      sqimap_mailbox_create($imap_stream, $mailbox, '');
      if ($imap_server_type == 'cyrus') {
	$boxes = sqimap_mailbox_list($imap_stream);
      } else {
	$boxes = sqimap_mailbox_list($imap_stream, true);
      }
      session_register($boxes, 'boxesnew');
      // echo "<foo sasql created: $box />";
    }

    if (!sqimap_mailbox_is_subscribed($imap_stream, $mailbox)) {
      sqimap_subscribe($imap_stream, $mailbox);
      if ($imap_server_type == 'cyrus') {
	$boxes = sqimap_mailbox_list($imap_stream);
      } else {
	$boxes = sqimap_mailbox_list($imap_stream, true);
      }
      session_register($boxes, 'boxesnew');
      // echo "<foo sasql subscried: $box />";
    }
  }

  sqimap_logout ($imap_stream);
  return 1;
}

function sasql_optpage_register_block () {
  global $optpage_blocks;

  // Set sasql gettext domain
  bindtextdomain ('sasql', SM_PATH . 'locale');
  textdomain ('sasql');

  $optpage_blocks[] =
    array (
	   'name' => _("Spam Filter Configuration"),
	   'url'  => '../plugins/sasql/sasql_options.php',
	   'desc' => _("Here you may configure the behavior of the spam filtering software."),
	   'js'   => FALSE);

  // Set gettext domain back to squirrelmail.
  bindtextdomain ('squirrelmail', SM_PATH . 'locale');
  textdomain ('squirrelmail');
}

// Partially adapted from code submitted by Pa55wa11 <dugan@passwall.com>
// some of which he claims was stollen from the spamassassin plugin.
function sasql_add_sa_wblist () {

  include_once(SM_PATH.'plugins/sasql/sasql_conf.php');
  include_once(SM_PATH.'plugins/sasql/sasql_db.php');

  global $mailbox;   // Current mailbox
  global $passed_id; // Message id
  global $ent_id;    // Entity id (jump back to attachment)
  global $startMessage; // Paginator index.

  // Set sasql gettext domain
  bindtextdomain ('sasql', SM_PATH . 'locale');
  textdomain ('sasql');

  // SM stuff
  global $username, $message, $sent_folder;

  // sasql stuff
  global $SqlDSN, $SqlTable;
  #global $use_quick_link;

  if (! $use_quick_link) {
    return;
  }

  // If we're in the Sent folder, then "our" address is the
  // from address.
  if ($mailbox == $sent_folder) {
    if (!$message->header->to) {
      $safrom = $message->rfc822_header->getAddr_s('to');
    } else {
      $safrom = $message->header->to[0];
    }
  } else {
    if (!$message->header->from) {
      $safrom = $message->rfc822_header->getAddr_s('from');
    } else {
      $safrom = $message->header->from;
    }
  }

  // Get the address out of the header
  preg_match("/([.-\w]+@[A-Za-z0-9\.]+[A-Za-z0-9\.-]+\.[A-Za-z0-9]+)/",
	     $safrom, $from_matches);
  $chkfrom = $from_matches[1];

  // Check for matches in the DB.
  $dbh = sasql_DBConnect($SqlDSN);
  if (DB::isError($dbh)) {
  } else {
    if ($safrom) {
      // Check whitelist
      $in_wlist = sasql_AddrInWBList ($dbh, $SqlTable, $username, 'w', $chkfrom);
      $in_gwlist = sasql_AddrInWBList ($dbh, $SqlTable, '@GLOBAL', 'w', $chkfrom);
      // Check blacklist
      $in_blist = sasql_AddrInWBList ($dbh, $SqlTable, $username, 'b', $chkfrom);
      $in_gblist = sasql_AddrInWBList ($dbh, $SqlTable, '@GLOBAL', 'b', $chkfrom);
    }
  }

  $sasql_optlink = "../plugins/sasql/sasql_options.php";
  $href = "../plugins/sasql/sasql_wblist.php?";
  $href .= "address=$chkfrom";
  $href .= "&mailbox=$mailbox";
  $href .= "&passed_id=$passed_id";
  $href .= "&startMessage=$startMessage";
  if ($ent_id) { $href .= "&ent_id=$ent_id"; }

  $wl_form = "<a title='"._('Add Email to Whitelist')."' href='$href";
  $wl_form .= "&action=new&preference=whitelist_from'>"._("Allow Sender")."</a>";
  $wl_delf = "<a title='"._('Remove Email from Whitelist')."' href='$href";
  $wl_delf .= "&action=delete&preference=whitelist_from'>"._("remove")."</a>";

  $bl_form = "<a title='"._('Add Email to Blacklist')."' href='$href";
  $bl_form .= "&action=new&preference=blacklist_from'>"._('Block Sender')."</a>";
  $bl_delf = "<a title='"._('Remove Email from Blacklist')."' href='$href";
  $bl_delf .= "&action=delete&preference=blacklist_from'>"._('remove')."</a>";

  // Whitelist
  if ($in_wlist or $in_gwlist) {
    $sa_link .= '<br><a href="' . $sasql_optlink .
                '?viewsection=sa_whitelist" title="' .
                _('Address is already in your whitelist') .
                '"><i>' . _("Whitelisted") . "</i></a> $chkfrom";
    if ($in_wlist) {
      $sa_link .= ' (' . $wl_delf . ')';
    }
  } elseif (! $in_blist and ! $in_gblist) {
    $sa_link .= '&nbsp;|&nbsp;'.$wl_form;
  }
  
  // Blacklist
  if ($in_blist or $in_gblist) {
    $sa_link .= '<br><a href="' . $sasql_optlink .
                '?viewsection=sa_whitelist" title="' .
                _('Address is already in your blacklist'). '"><i>' .
                _("Blacklisted") . "</i></a> $chkfrom";
    if ($in_blist) {
      $sa_link .= ' (' . $bl_delf . ')';
    }
  } elseif (! $in_wlist and ! $in_gwlist) {
    $sa_link .= '&nbsp;|&nbsp;'.$bl_form;
  }

  // Set gettext domain back to squirrelmail.
  bindtextdomain ('squirrelmail', SM_PATH . 'locale');
  textdomain ('squirrelmail');

  echo "$sa_link";
}

function sasql_report_spam_links() {
  // This only seems to work with include() but not include_once().
  include(SM_PATH.'plugins/sasql/sasql_conf.php');

  global $mailbox, $default_folder_prefix, $passed_id, $startMessage,
         $sort;
  #global $sasql_use_learn;

  if (! $sasql_use_learn) {
    return;
  }

  $action= 'right_main.php?'
    ."mailbox=$mailbox"
    ."&sort=$sort"
    ."&startMessage=$startMessage";

  $targetMailbox = $default_folder_prefix;
  if ($mailbox == $default_folder_prefix.$spam_folder) {
    $targetMailbox .= $learn_fp_folder;
    $submit = _('Learn as Spam');
  } else {
    $targetMailbox .= $learn_spam_folder;
    $submit = _('Learn as False Positive');
  }

  $form = "<form action='$action' method='Post'>";
  $form .= "<input type='hidden' name='move_id' value='$passed_id' />";
  $form .= "<input type='hidden' name='targetMailbox' value='$targetMailbox' />";
  $form .= "<input type='submit' value='$submit' />";
  $form .= '</form>';

  echo '<table width="100%" border="0"><tr>';
  echo "<td align='center'>";
  if ($mailbox != $default_folder_prefix.$learn_spam_folder
      && $mailbox != $default_folder_prefix.$learn_fp_folder) {
    echo $form;
  }
  echo "</td></tr></table>";
}

?>
